// Выбор текущего адреса
assign address = {cs,4'h0} + ip;

// Инициализация выходов
initial begin o_data = 8'b0; we = 1'b0; end

// -----------------------------------------------

// Регистры общего назначения
reg [15:0]  ax = 16'h0000;
reg [15:0]  bx = 16'h0000;
reg [15:0]  cx = 16'h0000;
reg [15:0]  dx = 16'h0000;
reg [15:0]  sp = 16'h0000;
reg [15:0]  bp = 16'h0000;
reg [15:0]  si = 16'h0000;
reg [15:0]  di = 16'h0000;

// Сегментные регистры
reg [15:0]  es = 16'h0000;
reg [15:0]  cs = 16'hF000;
reg [15:0]  ss = 16'h0000;
reg [15:0]  ds = 16'h0000;

// Флаги                ODIT SZ A  P C
reg [11:0]  flags = 12'b0000_0000_0000;
reg [15:0]  ip    = 16'hFFF0;

// Состояние процессора
// -----------------------------------------------
reg [ 5:0]  t           = 1'b0;
reg [ 7:0]  opcode      = 1'b0;
reg [15:0]  segment     = 16'h0000;
reg         segover     = 1'b0;
reg [ 1:0]  rep         = 2'b00;

// -----------------------------------------------
localparam
    init    = 1'b0,     // Стадия подготовки инструкции
    fetch   = 1'b1,     // Считывание опкода и префиксов
    exec    = 2'h2;     // Исполнение инструкции
